from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.cohort_service_get_historical_prepayments_json_body_convention import (
    CohortService_GetHistoricalPrepaymentsJsonBodyConvention,
)
from ..models.cohort_service_get_historical_prepayments_json_body_period import (
    CohortService_GetHistoricalPrepaymentsJsonBodyPeriod,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="CohortService_GetHistoricalPrepaymentsJsonBody")


@attr.s(auto_attribs=True)
class CohortService_GetHistoricalPrepaymentsJsonBody:
    """  """

    cohorts: Union[Unset, List[str]] = UNSET
    convention: Union[
        Unset, CohortService_GetHistoricalPrepaymentsJsonBodyConvention
    ] = CohortService_GetHistoricalPrepaymentsJsonBodyConvention.PERIOD
    num_months: Union[Unset, int] = UNSET
    period: Union[CohortService_GetHistoricalPrepaymentsJsonBodyPeriod, Unset] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cohorts: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cohorts, Unset):
            cohorts = self.cohorts

        convention: Union[
            Unset, CohortService_GetHistoricalPrepaymentsJsonBodyConvention
        ] = UNSET
        if not isinstance(self.convention, Unset):
            convention = self.convention

        num_months = self.num_months
        period: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.period, Unset):
            period = self.period.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cohorts is not UNSET:
            field_dict["cohorts"] = cohorts
        if convention is not UNSET:
            field_dict["convention"] = convention
        if num_months is not UNSET:
            field_dict["numMonths"] = num_months
        if period is not UNSET:
            field_dict["period"] = period

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cohorts = cast(List[str], d.pop("cohorts", UNSET))

        convention = None
        _convention = d.pop("convention", UNSET)
        if _convention is not None and _convention is not UNSET:
            convention = CohortService_GetHistoricalPrepaymentsJsonBodyConvention(
                _convention
            )

        num_months = d.pop("numMonths", UNSET)

        period: Union[
            CohortService_GetHistoricalPrepaymentsJsonBodyPeriod, Unset
        ] = UNSET
        _period = d.pop("period", UNSET)
        if not isinstance(_period, Unset):
            period = CohortService_GetHistoricalPrepaymentsJsonBodyPeriod.from_dict(
                cast(Dict[str, Any], _period)
            )

        cohort_service_get_historical_prepayments_json_body = cls(
            cohorts=cohorts,
            convention=convention,
            num_months=num_months,
            period=period,
        )

        cohort_service_get_historical_prepayments_json_body.additional_properties = d
        return cohort_service_get_historical_prepayments_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
