from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_prepayment_period import PoolPrepaymentPeriod
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolPrepaymentValue")


@attr.s(auto_attribs=True)
class PoolPrepaymentValue:
    """  """

    cpr: Union[Unset, float] = UNSET
    period: Union[PoolPrepaymentPeriod, Unset] = UNSET
    smm: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cpr = self.cpr
        period: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.period, Unset):
            period = self.period.to_dict()

        smm = self.smm

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cpr is not UNSET:
            field_dict["cpr"] = cpr
        if period is not UNSET:
            field_dict["period"] = period
        if smm is not UNSET:
            field_dict["smm"] = smm

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cpr = d.pop("cpr", UNSET)

        period: Union[PoolPrepaymentPeriod, Unset] = UNSET
        _period = d.pop("period", UNSET)
        if not isinstance(_period, Unset):
            period = PoolPrepaymentPeriod.from_dict(cast(Dict[str, Any], _period))

        smm = d.pop("smm", UNSET)

        pool_prepayment_value = cls(
            cpr=cpr,
            period=period,
            smm=smm,
        )

        pool_prepayment_value.additional_properties = d
        return pool_prepayment_value

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
