from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.pools_association import PoolsAssociation
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolsAssociations")


@attr.s(auto_attribs=True)
class PoolsAssociations:
    """  """

    associations: Union[Unset, List[PoolsAssociation]] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        associations: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.associations, Unset):
            associations = []
            for associations_item_data in self.associations:
                associations_item = associations_item_data.to_dict()

                associations.append(associations_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if associations is not UNSET:
            field_dict["associations"] = associations

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        associations = []
        _associations = d.pop("associations", UNSET)
        for associations_item_data in _associations or []:
            associations_item = PoolsAssociation.from_dict(associations_item_data)

            associations.append(associations_item)

        pools_associations = cls(
            associations=associations,
        )

        pools_associations.additional_properties = d
        return pools_associations

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
