from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.prediction_service_get_cohorts_json_body_as_of import (
    PredictionService_GetCohortsJsonBodyAsOf,
)
from ..models.prediction_service_get_cohorts_json_body_convention import (
    PredictionService_GetCohortsJsonBodyConvention,
)
from ..models.prediction_service_get_cohorts_json_body_methodtoaggregateprepaymentsforcohortsandportfolios import (
    PredictionService_GetCohortsJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
)
from ..models.prediction_service_get_cohorts_json_body_model import (
    PredictionService_GetCohortsJsonBodyModel,
)
from ..models.prediction_service_get_cohorts_json_body_scenario import (
    PredictionService_GetCohortsJsonBodyScenario,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PredictionService_GetCohortsJsonBody")


@attr.s(auto_attribs=True)
class PredictionService_GetCohortsJsonBody:
    """  """

    agg: Union[
        Unset,
        PredictionService_GetCohortsJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
    ] = (
        PredictionService_GetCohortsJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios.UPB
    )
    as_of: Union[PredictionService_GetCohortsJsonBodyAsOf, Unset] = UNSET
    cohorts: Union[Unset, List[str]] = UNSET
    convention: Union[
        Unset, PredictionService_GetCohortsJsonBodyConvention
    ] = PredictionService_GetCohortsJsonBodyConvention.PERIOD
    model: Union[
        Unset, PredictionService_GetCohortsJsonBodyModel
    ] = PredictionService_GetCohortsJsonBodyModel.ALL
    scenario: Union[
        Unset, PredictionService_GetCohortsJsonBodyScenario
    ] = PredictionService_GetCohortsJsonBodyScenario.BASELINE
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        agg: Union[
            Unset,
            PredictionService_GetCohortsJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
        ] = UNSET
        if not isinstance(self.agg, Unset):
            agg = self.agg

        as_of: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.as_of, Unset):
            as_of = self.as_of.to_dict()

        cohorts: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cohorts, Unset):
            cohorts = self.cohorts

        convention: Union[Unset, PredictionService_GetCohortsJsonBodyConvention] = UNSET
        if not isinstance(self.convention, Unset):
            convention = self.convention

        model: Union[Unset, PredictionService_GetCohortsJsonBodyModel] = UNSET
        if not isinstance(self.model, Unset):
            model = self.model

        scenario: Union[Unset, PredictionService_GetCohortsJsonBodyScenario] = UNSET
        if not isinstance(self.scenario, Unset):
            scenario = self.scenario

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if agg is not UNSET:
            field_dict["agg"] = agg
        if as_of is not UNSET:
            field_dict["asOf"] = as_of
        if cohorts is not UNSET:
            field_dict["cohorts"] = cohorts
        if convention is not UNSET:
            field_dict["convention"] = convention
        if model is not UNSET:
            field_dict["model"] = model
        if scenario is not UNSET:
            field_dict["scenario"] = scenario

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        agg = None
        _agg = d.pop("agg", UNSET)
        if _agg is not None and _agg is not UNSET:
            agg = PredictionService_GetCohortsJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios(
                _agg
            )

        as_of: Union[PredictionService_GetCohortsJsonBodyAsOf, Unset] = UNSET
        _as_of = d.pop("asOf", UNSET)
        if not isinstance(_as_of, Unset):
            as_of = PredictionService_GetCohortsJsonBodyAsOf.from_dict(
                cast(Dict[str, Any], _as_of)
            )

        cohorts = cast(List[str], d.pop("cohorts", UNSET))

        convention = None
        _convention = d.pop("convention", UNSET)
        if _convention is not None and _convention is not UNSET:
            convention = PredictionService_GetCohortsJsonBodyConvention(_convention)

        model = None
        _model = d.pop("model", UNSET)
        if _model is not None and _model is not UNSET:
            model = PredictionService_GetCohortsJsonBodyModel(_model)

        scenario = None
        _scenario = d.pop("scenario", UNSET)
        if _scenario is not None and _scenario is not UNSET:
            scenario = PredictionService_GetCohortsJsonBodyScenario(_scenario)

        prediction_service_get_cohorts_json_body = cls(
            agg=agg,
            as_of=as_of,
            cohorts=cohorts,
            convention=convention,
            model=model,
            scenario=scenario,
        )

        prediction_service_get_cohorts_json_body.additional_properties = d
        return prediction_service_get_cohorts_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
