from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.prediction_service_get_cohorts_look_ahead_json_body_ahead import (
    PredictionService_GetCohortsLookAheadJsonBodyAhead,
)
from ..models.prediction_service_get_cohorts_look_ahead_json_body_convention import (
    PredictionService_GetCohortsLookAheadJsonBodyConvention,
)
from ..models.prediction_service_get_cohorts_look_ahead_json_body_from import (
    PredictionService_GetCohortsLookAheadJsonBodyFrom,
)
from ..models.prediction_service_get_cohorts_look_ahead_json_body_methodtoaggregateprepaymentsforcohortsandportfolios import (
    PredictionService_GetCohortsLookAheadJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
)
from ..models.prediction_service_get_cohorts_look_ahead_json_body_model import (
    PredictionService_GetCohortsLookAheadJsonBodyModel,
)
from ..models.prediction_service_get_cohorts_look_ahead_json_body_scenario import (
    PredictionService_GetCohortsLookAheadJsonBodyScenario,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PredictionService_GetCohortsLookAheadJsonBody")


@attr.s(auto_attribs=True)
class PredictionService_GetCohortsLookAheadJsonBody:
    """  """

    agg: Union[
        Unset,
        PredictionService_GetCohortsLookAheadJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
    ] = (
        PredictionService_GetCohortsLookAheadJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios.UPB
    )
    ahead: Union[
        Unset, PredictionService_GetCohortsLookAheadJsonBodyAhead
    ] = PredictionService_GetCohortsLookAheadJsonBodyAhead.NONE
    cohorts: Union[Unset, List[str]] = UNSET
    convention: Union[
        Unset, PredictionService_GetCohortsLookAheadJsonBodyConvention
    ] = PredictionService_GetCohortsLookAheadJsonBodyConvention.PERIOD
    from_: Union[PredictionService_GetCohortsLookAheadJsonBodyFrom, Unset] = UNSET
    model: Union[
        Unset, PredictionService_GetCohortsLookAheadJsonBodyModel
    ] = PredictionService_GetCohortsLookAheadJsonBodyModel.ALL
    scenario: Union[
        Unset, PredictionService_GetCohortsLookAheadJsonBodyScenario
    ] = PredictionService_GetCohortsLookAheadJsonBodyScenario.BASELINE
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        agg: Union[
            Unset,
            PredictionService_GetCohortsLookAheadJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios,
        ] = UNSET
        if not isinstance(self.agg, Unset):
            agg = self.agg

        ahead: Union[Unset, PredictionService_GetCohortsLookAheadJsonBodyAhead] = UNSET
        if not isinstance(self.ahead, Unset):
            ahead = self.ahead

        cohorts: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cohorts, Unset):
            cohorts = self.cohorts

        convention: Union[
            Unset, PredictionService_GetCohortsLookAheadJsonBodyConvention
        ] = UNSET
        if not isinstance(self.convention, Unset):
            convention = self.convention

        from_: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.from_, Unset):
            from_ = self.from_.to_dict()

        model: Union[Unset, PredictionService_GetCohortsLookAheadJsonBodyModel] = UNSET
        if not isinstance(self.model, Unset):
            model = self.model

        scenario: Union[
            Unset, PredictionService_GetCohortsLookAheadJsonBodyScenario
        ] = UNSET
        if not isinstance(self.scenario, Unset):
            scenario = self.scenario

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if agg is not UNSET:
            field_dict["agg"] = agg
        if ahead is not UNSET:
            field_dict["ahead"] = ahead
        if cohorts is not UNSET:
            field_dict["cohorts"] = cohorts
        if convention is not UNSET:
            field_dict["convention"] = convention
        if from_ is not UNSET:
            field_dict["from"] = from_
        if model is not UNSET:
            field_dict["model"] = model
        if scenario is not UNSET:
            field_dict["scenario"] = scenario

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        agg = None
        _agg = d.pop("agg", UNSET)
        if _agg is not None and _agg is not UNSET:
            agg = PredictionService_GetCohortsLookAheadJsonBodyMethodtoaggregateprepaymentsforcohortsandportfolios(
                _agg
            )

        ahead = None
        _ahead = d.pop("ahead", UNSET)
        if _ahead is not None and _ahead is not UNSET:
            ahead = PredictionService_GetCohortsLookAheadJsonBodyAhead(_ahead)

        cohorts = cast(List[str], d.pop("cohorts", UNSET))

        convention = None
        _convention = d.pop("convention", UNSET)
        if _convention is not None and _convention is not UNSET:
            convention = PredictionService_GetCohortsLookAheadJsonBodyConvention(
                _convention
            )

        from_: Union[PredictionService_GetCohortsLookAheadJsonBodyFrom, Unset] = UNSET
        _from_ = d.pop("from", UNSET)
        if not isinstance(_from_, Unset):
            from_ = PredictionService_GetCohortsLookAheadJsonBodyFrom.from_dict(
                cast(Dict[str, Any], _from_)
            )

        model = None
        _model = d.pop("model", UNSET)
        if _model is not None and _model is not UNSET:
            model = PredictionService_GetCohortsLookAheadJsonBodyModel(_model)

        scenario = None
        _scenario = d.pop("scenario", UNSET)
        if _scenario is not None and _scenario is not UNSET:
            scenario = PredictionService_GetCohortsLookAheadJsonBodyScenario(_scenario)

        prediction_service_get_cohorts_look_ahead_json_body = cls(
            agg=agg,
            ahead=ahead,
            cohorts=cohorts,
            convention=convention,
            from_=from_,
            model=model,
            scenario=scenario,
        )

        prediction_service_get_cohorts_look_ahead_json_body.additional_properties = d
        return prediction_service_get_cohorts_look_ahead_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
