from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.search_service_search_json_body_predictions_pred1m_cpr_delta_range import (
    SearchService_SearchJsonBodyPredictionsPred1mCprDeltaRange,
)
from ..models.search_service_search_json_body_predictions_pred1m_cpr_range import (
    SearchService_SearchJsonBodyPredictionsPred1mCprRange,
)
from ..models.search_service_search_json_body_predictions_pred3m_cpr_range import (
    SearchService_SearchJsonBodyPredictionsPred3mCprRange,
)
from ..models.search_service_search_json_body_predictions_pred6m_cpr_range import (
    SearchService_SearchJsonBodyPredictionsPred6mCprRange,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBodyPredictions")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBodyPredictions:
    """  """

    pred1m_cpr_delta_range: Union[
        SearchService_SearchJsonBodyPredictionsPred1mCprDeltaRange, Unset
    ] = UNSET
    pred1m_cpr_range: Union[
        SearchService_SearchJsonBodyPredictionsPred1mCprRange, Unset
    ] = UNSET
    pred3m_cpr_range: Union[
        SearchService_SearchJsonBodyPredictionsPred3mCprRange, Unset
    ] = UNSET
    pred6m_cpr_range: Union[
        SearchService_SearchJsonBodyPredictionsPred6mCprRange, Unset
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        pred1m_cpr_delta_range: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.pred1m_cpr_delta_range, Unset):
            pred1m_cpr_delta_range = self.pred1m_cpr_delta_range.to_dict()

        pred1m_cpr_range: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.pred1m_cpr_range, Unset):
            pred1m_cpr_range = self.pred1m_cpr_range.to_dict()

        pred3m_cpr_range: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.pred3m_cpr_range, Unset):
            pred3m_cpr_range = self.pred3m_cpr_range.to_dict()

        pred6m_cpr_range: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.pred6m_cpr_range, Unset):
            pred6m_cpr_range = self.pred6m_cpr_range.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if pred1m_cpr_delta_range is not UNSET:
            field_dict["pred1mCprDeltaRange"] = pred1m_cpr_delta_range
        if pred1m_cpr_range is not UNSET:
            field_dict["pred1mCprRange"] = pred1m_cpr_range
        if pred3m_cpr_range is not UNSET:
            field_dict["pred3mCprRange"] = pred3m_cpr_range
        if pred6m_cpr_range is not UNSET:
            field_dict["pred6mCprRange"] = pred6m_cpr_range

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        pred1m_cpr_delta_range: Union[
            SearchService_SearchJsonBodyPredictionsPred1mCprDeltaRange, Unset
        ] = UNSET
        _pred1m_cpr_delta_range = d.pop("pred1mCprDeltaRange", UNSET)
        if not isinstance(_pred1m_cpr_delta_range, Unset):
            pred1m_cpr_delta_range = (
                SearchService_SearchJsonBodyPredictionsPred1mCprDeltaRange.from_dict(
                    cast(Dict[str, Any], _pred1m_cpr_delta_range)
                )
            )

        pred1m_cpr_range: Union[
            SearchService_SearchJsonBodyPredictionsPred1mCprRange, Unset
        ] = UNSET
        _pred1m_cpr_range = d.pop("pred1mCprRange", UNSET)
        if not isinstance(_pred1m_cpr_range, Unset):
            pred1m_cpr_range = (
                SearchService_SearchJsonBodyPredictionsPred1mCprRange.from_dict(
                    cast(Dict[str, Any], _pred1m_cpr_range)
                )
            )

        pred3m_cpr_range: Union[
            SearchService_SearchJsonBodyPredictionsPred3mCprRange, Unset
        ] = UNSET
        _pred3m_cpr_range = d.pop("pred3mCprRange", UNSET)
        if not isinstance(_pred3m_cpr_range, Unset):
            pred3m_cpr_range = (
                SearchService_SearchJsonBodyPredictionsPred3mCprRange.from_dict(
                    cast(Dict[str, Any], _pred3m_cpr_range)
                )
            )

        pred6m_cpr_range: Union[
            SearchService_SearchJsonBodyPredictionsPred6mCprRange, Unset
        ] = UNSET
        _pred6m_cpr_range = d.pop("pred6mCprRange", UNSET)
        if not isinstance(_pred6m_cpr_range, Unset):
            pred6m_cpr_range = (
                SearchService_SearchJsonBodyPredictionsPred6mCprRange.from_dict(
                    cast(Dict[str, Any], _pred6m_cpr_range)
                )
            )

        search_service_search_json_body_predictions = cls(
            pred1m_cpr_delta_range=pred1m_cpr_delta_range,
            pred1m_cpr_range=pred1m_cpr_range,
            pred3m_cpr_range=pred3m_cpr_range,
            pred6m_cpr_range=pred6m_cpr_range,
        )

        search_service_search_json_body_predictions.additional_properties = d
        return search_service_search_json_body_predictions

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
